--- apt-cacher-1.6.8/apt-cacher2	2009-02-22 15:30:20.000000000 -0500
+++ apt-cacher-1.6.8/apt-cacher2.new	2009-08-14 02:54:51.000000000 -0400
@@ -529,9 +529,17 @@
 
 	if (&is_package_file($filename)){
 	    # We must be fetching a .deb or a .rpm or some other recognised
-	    # file, so let's cache it.
-	    # Place the file in the cache with just its basename
-	    $new_filename = $filename;
+	    # file, so let's cache it. Make a unique filename so that we
+	    # can cache packages from multiple distributions (e.g. Debian,
+	    # Ubuntu) without name collisions, but if we only have a
+	    # package with a non-unique name in the cache, then use that.
+	    $new_filename = "$host$uri";
+	    $new_filename =~ s,/([^/]+)$,:$1,;  # makes demunging easier
+	    $new_filename =~ s,/,_,g;
+	    if (!-f "$cfg->{cache_dir}/packages/$new_filename" &&
+		 -f "$cfg->{cache_dir}/packages/$filename") {
+		$new_filename = $filename;
+	    }
 	    debug_message("new base file: $new_filename");
 	}
 	elsif ($filename =~ /2\d\d\d-\d\d-\d\d.*\.gz$/) {
